//
//  ViewController.m
//  iMag
//
//  Created by ID TECH on 16/4/15.
//  Copyright © 2016年 ID TECH. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()

@end

@implementation ViewController

@synthesize versionLabel;
@synthesize connectedLabel;
@synthesize	textResponse;
@synthesize	hexResponse;
@synthesize	textCMDInput;
@synthesize	butnSend1;

static bool isInView = NO;
static int s_opendev=0;

//Shawn Li, 2019-10-8, iOS 13.1.x, NSData.description include "length = xxx, bytes = 0xXXXX", so use this function getNSData_description to replace the NSData.description.
static NSString* getNSData_description(NSData* byteArray);


- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    textResponse.layoutManager.allowsNonContiguousLayout = NO;
    hexResponse.layoutManager.allowsNonContiguousLayout = NO;
    
    //get version from info.plist and display it on ui
    CFStringRef cfsVer = (CFStringRef)CFBundleGetValueForInfoDictionaryKey(
                                                                           CFBundleGetMainBundle(), kCFBundleVersionKey);
    versionLabel.text = [NSString stringWithFormat:@"iMag %@",
                         (__bridge NSString *)cfsVer]; //toll free bridging
    
    [self InitReader: NULL];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

-(void) appendMessageToResults:(NSString*) message{
    [self.hexResponse setText:[NSString stringWithFormat:@"%@\n%@", self.hexResponse.text, message]];
    [self.hexResponse scrollRangeToVisible:NSMakeRange([self.hexResponse.text length], 0)];
    //NSString *str1 = [NSString stringWithFormat:@"%@\n%@", self.textResponse.text, message];
    //[self.textResponse setText:str1];
}

-(IBAction)InitReader:(id)sender{
    NSLog(@"YES");
    if (!isInView)
    {
        [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(uniAccessoryConnected:) name:@"iMagDidConnectNotification" object:nil];
        [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(uniAccessoryDisconnected:) name:@"iMagDidDisconnectNotification" object:nil];
        [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(accessoryData:) name:@"iMagDidReceiveDataNotification" object:nil];
        isInView = YES;
        
        [iMag enableLogging: TRUE]; //enable info level logging
        iReader = [[iMag alloc] init];
        [self appendMessageToResults: @"init."];
    }
    
}


-(IBAction)DestoryReader:(id)sender{
    if (isInView){
        [[NSNotificationCenter defaultCenter] removeObserver:self name:@"iMagDidConnectNotification" object:nil];
        [[NSNotificationCenter defaultCenter] removeObserver:self name:@"iMagDidDisconnectNotification" object:nil];
        [[NSNotificationCenter defaultCenter] removeObserver:self name:@"iMagDidReceiveDataNotification" object:nil];
        isInView = NO;
        
        iReader = nil;
//        connectedLabel.text = @"DISCONNECTED";
//        [self appendMessageToResults: @"release."];
        s_opendev=0;
    }
}

- (IBAction) DoKeyboardOff:(id)sender{
    [sender resignFirstResponder];
}

-(IBAction)DoClearText1:(id)sender{
    textResponse.text = @"";
}

-(IBAction)DoClearText2:(id)sender{
    hexResponse.text = @"";
}

-(BOOL) isValidChar:(Byte)byChar{
    if ( ((byChar>(Byte)0x2F) && (byChar<(Byte)0x3A)) //'0' - '9'
        || ((byChar>(Byte)0x40) && (byChar<(Byte)0x47)) //'A' - 'F'
        || ((byChar>(Byte)0x60) && (byChar<(Byte)0x67)) //'a' - 'f'
        )
    {
        return YES;
    }
    return NO;
}

-(NSData*) hexStringToBytes:(NSString*)hexString{
    if (hexString.length<1) {
        return nil;
    }
    
    char tmpCh[1024] = {0};
    int count = 0;
    for (int k=0; k<hexString.length;k++) {
        char c = [hexString characterAtIndex:k];
        if (c == (char)0x20) {
            continue;
        }
        tmpCh[count] = c;
        count++;
    }
    tmpCh[count] = 0;
    
    if (count % 2) {
        return nil;
    }
    
    NSString *temp = [[NSString alloc] initWithUTF8String:tmpCh];
    int m = temp.length % 2;
    if (m>0) {
        return nil;
    }
    
    NSMutableData *result = [[NSMutableData alloc] init];
    unsigned char byte;
    char hexChars[3] = {0};
    for (int i=0; i < (temp.length/2); i++) {
        hexChars[0] = [temp characterAtIndex:i*2];
        hexChars[1] = [temp characterAtIndex:i*2+1];
        
        if (![self isValidChar:hexChars[0]] || ![self isValidChar:hexChars[1]]) {
            return nil;
        }
        byte = strtol(hexChars, NULL, 16);
        [result appendBytes:&byte length:1];
    }
    return [NSData dataWithData:result];
}

- (void)uniAccessoryConnected:(NSNotification *)notification
{
    //This observer is called when the external accessory gets connected
    connectedLabel.text = @"CONNECTED";
    [self appendMessageToResults: @"<Connected>"];
    s_opendev=1;
}


- (void)uniAccessoryDisconnected:(NSNotification *)notification
{
    //This observer is called when the external accessory disconnects from the phone
    connectedLabel.text = @"DISCONNECTED";
    [self appendMessageToResults: @"<Disconnected>"];
    s_opendev=0;
}

- (void)accessoryData:(NSNotification *)notification
{
    //This observer is called when data comes in from the reader; NSData Object is received
    NSData *data = (NSData *)[notification object];
    textResponse.text = [[NSString alloc] initWithData:data encoding:NSASCIIStringEncoding];
    [self appendMessageToResults: @"card data:"];
    
    //Shawn Li, 2019-10-8, iOS 13.1.x, NSData.description include "length = xxx, bytes = 0xXXXX", so use this function getNSData_description to replace the NSData.description.
    //[self appendMessageToResults: [data description]];
    [self appendMessageToResults: getNSData_description(data)];
    
    unsigned char *byData = (unsigned char*)[data bytes];
    bool bKSN = (byData[3]==(Byte)0x80);
    if (bKSN) {
        if ((Byte)0x80==(byData[9]&(Byte)0x80)) {
            //[self appendMessageToResults: @"ksn:"];
            
            unsigned long index = data.length-13;
            NSMutableData *result = [[NSMutableData alloc] init];
            [result appendBytes: &byData[index] length:10];
            
            //Shawn Li, 2019-10-8, iOS 13.1.x, NSData.description include "length = xxx, bytes = 0xXXXX", so use this function getNSData_description to replace the NSData.description.
            //[self appendMessageToResults: [NSString stringWithFormat:@"KSN: %@", [result description]]];
            [self appendMessageToResults: [NSString stringWithFormat:@"KSN: %@", getNSData_description(result)]];
            
            //[result release];
            result = nil;
            
        }
    }
}


-(IBAction)sendCommand1:(id)sender{
    [textCMDInput resignFirstResponder];
    if(s_opendev)
    {
        NSString *str1 = textCMDInput.text;
        
        NSData *data = [self hexStringToBytes: str1];
        if (data.length<1){
            return;
        }
        BOOL bShowString = NO;
        if (data.length>1) {
            unsigned char *dataBytes = (unsigned char*)[data bytes];
            if ((0x52 == (Byte)dataBytes[0])&&
                (0x22 == (Byte)dataBytes[1])) {
                bShowString = YES;
            }
        }
        
        NSData *rawResult= [iReader SendCMD: data];
        
        //Shawn Li, 2019-10-8, iOS 13.1.x, NSData.description include "length = xxx, bytes = 0xXXXX", so use this function getNSData_description to replace the NSData.description.
        //[self appendMessageToResults: [NSString stringWithFormat:@"CMD response: \n%@", rawResult.description]];
        [self appendMessageToResults: [NSString stringWithFormat:@"CMD response: \n%@", getNSData_description(rawResult)]];

        if (bShowString) {
            //unsigned char* tempResult=(unsigned char*)[rawResult bytes];
            
            //NSData *data =[NSData dataWithBytes:tempResult length:rawResult.length-1];
            NSString *str = [[NSString alloc] initWithData:rawResult encoding:NSUTF8StringEncoding];
            [self.textResponse setText:[NSString stringWithFormat:@"%@\n%@", self.textResponse.text, str]];
            [self.textResponse scrollRangeToVisible:NSMakeRange([self.textResponse.text length], 0)];
        }
    }
    else {
        
        [self appendMessageToResults:@"Haven't opened device!"];
    }
    
}


//Shawn Li, 2019-10-8, iOS 13.1.x, NSData.description include "length = xxx, bytes = 0xXXXX", so use this function to replace the NSData.description.
static NSString* getNSData_description(NSData* byteArray) {
    NSMutableString * ret = [NSMutableString string];
    
    @autoreleasepool
    {
        const int len = (int)byteArray.length;
        const Byte *bytes = byteArray.bytes;
        NSString *chr=nil;
        
        [ret appendString: @"<"];
        if (len>0){
            for (int i=0; i<len; i++)
            {
                chr = [NSString stringWithFormat:@"%02x", bytes[i]];
                
                if ((i>0) && (0==i%4)){
                    [ret appendString: @" "];
                }
                //
                [ret appendString: chr];
                
            }
        }
        else
        {
            [ret appendString: @"NULL"];
        }
        [ret appendString: @">"];
    }
    
    return ret;
}

@end
